use super::schema::banks;
use beteran_common_rust as bcr;

///
#[derive(Eq, Hash, Identifiable, Queryable, PartialEq, PartialOrd, Debug, Clone)]
#[table_name = "banks"]
pub struct Bank {
  ///
  pub id: uuid::Uuid,
  ///
  pub name: String,
  ///
  pub sort_order: i32,
  ///
  pub show: bool,
  ///
  pub can_use: bool,
  ///
  pub memo: Option<String>,
  ///
  pub created_at: i64,
  ///
  pub updated_at: i64,
}

///
#[derive(Insertable, Debug, Clone)]
#[table_name = "banks"]
pub struct NewBank {
  ///
  pub name: String,
  ///
  pub sort_order: i32,
  ///
  pub show: bool,
  ///
  pub can_use: bool,
  ///
  pub memo: Option<String>,
}

///
#[derive(AsChangeset, Debug, Clone)]
#[table_name = "banks"]
pub struct ModifyBank {
  ///
  pub name: String,
  ///
  pub sort_order: i32,
  ///
  pub show: bool,
  ///
  pub can_use: bool,
  ///
  pub memo: Option<String>,
}

///
#[derive(Debug, Clone)]
pub struct FindAllSearch {
  ///
  pub name_like: Option<String>,
  ///
  pub show: Option<bool>,
  ///
  pub can_use: Option<bool>,
  ///
  pub memo_like: Option<String>,
}
///
#[derive(Debug, Clone)]
pub struct FindAll {
  pub search: Option<FindAllSearch>,
  ///
  pub pagination: Option<bcr::models::pagination::Pagination>,
  ///
  pub sorts: Option<Vec<bcr::models::pagination::Sort>>,
}
